# IVFSExplorer Interface Reference

The VFSExplorer interface unifies access to different file system types. More...

List of all members.

## Public Member Functions
void | update ([retval] out IProgress aProgress)
| Updates the internal list of files/directories from the current directory level.
void | cd (in wstring aDir,[retval] out IProgress aProgress)
| Change the current directory level.
void | cdUp ([retval] out IProgress aProgress)
| Go one directory upwards from the current directory level.
void | entryList (out wstring[] aNames, out unsigned long[] aTypes)
| Returns a list of files/directories after a call to update.
void | exists (in wstring[] aNames,[retval] out wstring[] aExists)
| Checks if the given file list exists in the current directory level.
void | remove (in wstring[] aNames,[retval] out IProgress aProgress)
| Deletes the given files in the current directory level.
## Public Attributes
readonly attribute wstring | path
| Returns the current path in the virtual file system.
readonly attribute VFSType | type
| Returns the file system type which is currently in use.

## Detailed Description

The VFSExplorer interface unifies access to different file system types.

This includes local file systems as well remote file systems like S3. For a list of supported types see VFSType. An instance of this is returned by IAppliance::createVFSExplorer.

Interface ID:
  `{2BB864A1-02A3-4474-A1D4-FB5F23B742E1}`

## Member Function Documentation

void IVFSExplorer::update | ( | [retval] out IProgress | aProgress | ) |

Updates the internal list of files/directories from the current directory level.

Use entryList to get the full list after a call to this method.

Parameters:

  | aProgress | Progress object to track the operation completion.

void IVFSExplorer::cd | ( | in wstring | aDir,
|  | [retval] out IProgress | aProgress |
| ) |  |  |

Change the current directory level.

Parameters:

  | aDir | The name of the directory to go in.
  | aProgress | Progress object to track the operation completion.

void IVFSExplorer::cdUp | ( | [retval] out IProgress | aProgress | ) |

Go one directory upwards from the current directory level.

Parameters:

  | aProgress | Progress object to track the operation completion.

void IVFSExplorer::entryList | ( | out wstring[] | aNames,
|  | out unsigned long[] | aTypes |
| ) |  |  |

Returns a list of files/directories after a call to update.

The user is responsible for keeping this internal list up do date.

Parameters:

  | aNames | The list of names for the entries.
  | aTypes | The list of types for the entries.

void IVFSExplorer::exists | ( | in wstring[] | aNames,
|  | [retval] out wstring[] | aExists |
| ) |  |  |

Checks if the given file list exists in the current directory level.

Parameters:

  | aNames | The names to check.
  | aExists | The names which exist.

void IVFSExplorer::remove | ( | in wstring[] | aNames,
|  | [retval] out IProgress | aProgress |
| ) |  |  |

Deletes the given files in the current directory level.

Parameters:

  | aNames | The names to remove.
  | aProgress | Progress object to track the operation completion.

## Member Data Documentation

readonly attribute wstring IVFSExplorer::path

Returns the current path in the virtual file system.

readonly attribute VFSType IVFSExplorer::type

Returns the file system type which is currently in use.